'' MPE_SPI_DOGM_005
'' DOGM 4-PIN 2008-01 by deSilva



' ----- The following section is a test routine
    _clkmode        = xtal1 + pll8x
    _xinfreq        = 10_000_000


    LINES = 32

PUB checkOut | i , scroll
  init(0)
  
  ' slow wipeout
  REPEAT i FROM 0 TO LINES/8-1 
     clearPage(i)

  
  write(string($B0,$10),3,0)
  REPEAT 16
     write(string($01,$03,$07,$0f,$1f,$3f,$7f,$ff),8,1)


  write(string($B1, $10),3,0)
  REPEAT 16
     write(string($18,$3c,$7e,$ff,$10,$08,$10,$08),8,1)

  write(string($B2,$10),3,0)
  REPEAT 16
     write(string($01,$03,$07,$0f,$1f,$3f,$7f,$ff),8,1)

  write(string($B6, $10),3,0)
  REPEAT 16*8
     write(string($FF),1,1)



  flash
  

 aString(string("Regards:",10,"deSilva!"))
 

  REPEAT 32*5
    scroll++
    scroll &= 63
    scroll |= $40
    write(@scroll,1,0)
    waitcnt(CNT+clkfreq/20)

  REPEAT
     flash
     
PRI flash
    write(string($A7),1,0)
    waitcnt(CNT+clkfreq)      
    write(string($A6),1,0)
    waitcnt(CNT+clkfreq)
    
PUB aString(s) | n, g, p
  n:= -16
  p := 0
  REPEAT WHILE g := BYTE[s++]
     IF g == 10
        p := 4   ' next line
        n :=-16
     ELSE
        aGlyph(g, n+=16, p)


'----- Here starts the driver


'----- Here starts the driver

CON 
  #0,SD,SCL,A0,CS   ' using I/O 0..3 change whenever appropriate
PUB write(dataAddr, nmbBytes, thisA0): data

  outa[CS]~
  outa[A0] := thisA0
  REPEAT WHILE nmbBytes-- > 0
    IF dataAddr
      data := BYTE[dataAddr++] >< 8 'revert each byte         
    REPEAT 8                   'transfer from D7 to D0
      outa[SCL]~               'clock goes low
      outa[SD] := data
      outa[SCL]~~              'transfer at rising edge
      data >>= 1
  outa[a0]~                                             
  outa[CS]~~      



DAT
initDOGM BYTE $40   'Start line =0
      BYTE $A0      'ADC reverse
      BYTE $C8      'reverse COM
      BYTE $A6      'normal display
      BYTE $A2      'set bias 1/9
      BYTE $2F      'set Booster
      BYTE $F8, $00 'set Booster x4
      BYTE $25      ' change here for contrast: $24..$27
      BYTE $81, $03 'set contrast ($3f to $00)
      BYTE $AC, $01 'no static indicator
      BYTE $AF      ' Display ON      
initDOGMend BYTE

clearDOGM BYTE $B0   ' set line
      BYTE $40
      BYTE $10        ' set low nibble
      BYTE $00        ' set high nibble
clearDOGMend BYTE

PUB init(upsidedown)  
  OUTA[CS]~~
  OUTA[SCL]~~
  DIRA[SD..CS]~~
  ' SpiWrite(string($E2),1,0) ' internal reset
  write(@initDOGM, constant(@initDOGMend-@initDOGM) , 0)
  IF upsidedown
    write(string($A1,$C6),2,0)

PUB clearPage(page)
  clearDOGM &= $f0
  clearDOGM |= page
  write(@clearDOGM, constant(@clearDOGMend-@clearDOGM) , 0)
  write(0, $84, 1) 


         
PUB aGlyph(glyph, dPos, startPage)   | posString, shift, shift0, c, cBase  , page, row
 cbase := $8000+ glyph/2*128
 shift0 := glyph//2
 posString.byte[2] := $00 + dPos&15
 posString.byte[1] := $10 +(dPos>>4)
 REPEAT page FROM 0 to 3
    posString.byte[0] := $B0 + page+startPage
    write(@posString,3,0)
    REPEAT shift FROM shift0 TO 31+shift0 step 2
      c :=0 
      REPEAT row FROM 0 to 7
        c |= ((LONG[cBase][row+page*8]>>shift)&1) << row
      write(@c,1,1)     